regina::SnapPeaCensusTri Class Reference
Standard Triangulations and Subcomplexes

Represents a 3-manifold triangulation from the SnapPea cusped census. More...

`#include <subcomplex/snappeacensustri.h>`

Inheritance diagram for regina::SnapPeaCensusTri:

## Public Member Functions

SnapPeaCensusTri * | clone () const
| Returns a newly created clone of this structure. More...
char | section () const
| Returns the section of the SnapPea census to which this triangulation belongs. More...
unsigned long | index () const
| Returns the index of this triangulation within its particular section of the SnapPea census. More...
bool | operator== (const SnapPeaCensusTri &compare) const
| Determines whether this and the given structure represent the same triangulation from the SnapPea census. More...
bool | operator!= (const SnapPeaCensusTri &compare) const
| Determines whether this and the given structure represent different triangulations from the SnapPea census. More...
Manifold * | manifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
AbelianGroup * | homology () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
std::string | name () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | TeXName () const
| Returns the name of this specific triangulation in TeX format. More...
AbelianGroup * | homologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Static Public Member Functions

static SnapPeaCensusTri * | isSmallSnapPeaCensusTri (const Component< 3 > *comp)
| Determines if the given triangulation component is one of the smallest SnapPea census triangulations. More...
static StandardTriangulation * | isStandardTriangulation (Component< 3 > *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static StandardTriangulation * | isStandardTriangulation (Triangulation< 3 > *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Static Public Attributes

static const char | SEC_5
| Represents the collection of triangulations formed from five or fewer tetrahedra (both orientable and non-orientable). More...
static const char | SEC_6_OR
| Represents the collection of orientable triangulations formed from six tetrahedra. More...
static const char | SEC_6_NOR
| Represents the collection of non-orientable triangulations formed from six tetrahedra. More...
static const char | SEC_7_OR
| Represents the collection of orientable triangulations formed from seven tetrahedra. More...
static const char | SEC_7_NOR
| Represents the collection of non-orientable triangulations formed from seven tetrahedra. More...

## Friends

class | SnapPeaCensusManifold

## Detailed Description

Represents a 3-manifold triangulation from the SnapPea cusped census.

The SnapPea cusped census is the census of cusped hyperbolic 3-manifolds formed from up to seven tetrahedra. This census was tabulated by Callahan, Hildebrand and Weeks, and is shipped with SnapPea 3.0d3 (and also with Regina).

Note
  The modern cusped hyperbolic census now extends to nine tetrahedra, and indeed the 9-tetrahedron database is accessible through the Census lookup routines. However, for the time being, the scope of these SnapPeaCensusManifold and SnapPeaCensusTri classes is restricted to the original Callahan-Hildebrand-Weeks 7-tetrahedron census only.

The census is split into five different sections according to number of tetrahedra and orientability. Each of these sections corresponds to one of the section constants defined in this class.

For further details regarding the SnapPea census, see "A census of cusped hyperbolic 3-manifolds", Patrick J. Callahan, Martin V. Hildebrand and Jeffrey R. Weeks, Math. Comp. 68 (1999), no. 225, pp. 321–332.

Note that this class is closely tied to SnapPeaCensusManifold. In particular, the section constants defined in SnapPeaCensusManifold and SnapPeaCensusTri are identical, and so may be freely mixed. Furthermore, the section and index parameters of a SnapPeaCensusTri are identical to those of its corresponding SnapPeaCensusManifold.

All of the optional StandardTriangulation routines are implemented for this class.

## Member Function Documentation

## clone()

SnapPeaCensusTri * regina::SnapPeaCensusTri::clone | ( |  | ) | const

inline

Returns a newly created clone of this structure.

Returns
  a newly created clone.

## detail()

std::string regina::Output< StandardTriangulation , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## homology()

AbelianGroup* regina::SnapPeaCensusTri::homology | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homologyH1() (a name that is more specific, but a little longer to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::StandardTriangulation.

## homologyH1()

AbelianGroup * regina::StandardTriangulation::homologyH1 | ( |  | ) | const

inline inherited

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homology() (a name that is less specific, but a little easier to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

## index()

unsigned long regina::SnapPeaCensusTri::index | ( |  | ) | const

inline

Returns the index of this triangulation within its particular section of the SnapPea census.

Note that indices for each section begin counting at zero.

Returns
  the index of this triangulation within its section.

## isSmallSnapPeaCensusTri()

static SnapPeaCensusTri* regina::SnapPeaCensusTri::isSmallSnapPeaCensusTri | ( | const Component< 3 > * | comp | ) |

static

Determines if the given triangulation component is one of the smallest SnapPea census triangulations.

This routine is able to recognise a small selection of triangulations from the beginning of the SnapPea census, by way of hard-coding their structures and properties. Most triangulations from the census however will not be recognised by this routine.

Parameters

  comp | the triangulation component to examine.

Returns
  a newly created structure representing the small SnapPea census triangulation, or `null` if the given component is not one of the few SnapPea census triangulations recognised by this routine.

## isStandardTriangulation() [1/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Component< 3 > * | component | ) |

static inherited

Determines whether the given component represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given component must have the same corresponding boundary triangles, i.e., the component cannot have any further identifications of these boundary triangles with each other.

Note that the triangulation-based routine isStandardTriangulation(Triangulation<3>*) may recognise more triangulations than this routine, since passing an entire triangulation allows access to more information.

Parameters

  component | the triangulation component under examination.

Returns
  the details of the standard triangulation if the given component is recognised, or 0 otherwise.

## isStandardTriangulation() [2/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Triangulation< 3 > * | tri | ) |

static inherited

Determines whether the given triangulation represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given triangulation must have the same corresponding boundary triangles, i.e., the triangulation cannot have any further identifications of these boundary triangles with each other.

This routine may recognise more triangulations than the component-based isStandardTriangulation(Component<3>*), since passing an entire triangulation allows access to more information.

Parameters

  tri | the triangulation under examination.

Returns
  the details of the standard triangualation if the given triangulation is recognised, or 0 otherwise.

## manifold()

Manifold* regina::SnapPeaCensusTri::manifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::StandardTriangulation.

## name()

std::string regina::StandardTriangulation::name | ( |  | ) | const

inherited

Returns the name of this specific triangulation as a human-readable string.

Returns
  the name of this triangulation.

## operator!=()

bool regina::SnapPeaCensusTri::operator!= | ( | const SnapPeaCensusTri & | compare | ) | const

inline

Determines whether this and the given structure represent different triangulations from the SnapPea census.

Parameters

  compare | the structure with which this will be compared.

Returns
  `true` if and only if this and the given structure represent different SnapPea census triangulations.

## operator==()

bool regina::SnapPeaCensusTri::operator== | ( | const SnapPeaCensusTri & | compare | ) | const

inline

Determines whether this and the given structure represent the same triangulation from the SnapPea census.

Parameters

  compare | the structure with which this will be compared.

Returns
  `true` if and only if this and the given structure represent the same SnapPea census triangulation.

## section()

char regina::SnapPeaCensusTri::section | ( |  | ) | const

inline

Returns the section of the SnapPea census to which this triangulation belongs.

This will be one of the section constants defined in this class.

Returns
  the section of the SnapPea census.

## str()

std::string regina::Output< StandardTriangulation , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:
  In addition to str(), this is also used as the Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## TeXName()

std::string regina::StandardTriangulation::TeXName | ( |  | ) | const

inherited

Returns the name of this specific triangulation in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the name of this triangulation in TeX format.

## utf8()

std::string regina::Output< StandardTriangulation , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## writeName()

std::ostream& regina::SnapPeaCensusTri::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTeXName()

std::ostream& regina::SnapPeaCensusTri::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTextLong()

void regina::StandardTriangulation::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes a detailed text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

Reimplemented in regina::LayeredSolidTorus, regina::TriSolidTorus, regina::LayeredChain, regina::AugTriSolidTorus, regina::SpiralSolidTorus, regina::LayeredTorusBundle, regina::PlugTriSolidTorus, regina::BlockedSFSTriple, regina::PluggedTorusBundle, regina::LayeredLensSpace, regina::BlockedSFSLoop, regina::SnappedBall, regina::LayeredLoop, regina::BlockedSFSPair, regina::TrivialTri, regina::L31Pillow, regina::LayeredChainPair, and regina::BlockedSFS.

## writeTextShort()

void regina::StandardTriangulation::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes a short text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

## Member Data Documentation

## SEC_5

const char regina::SnapPeaCensusTri::SEC_5

static

Represents the collection of triangulations formed from five or fewer tetrahedra (both orientable and non-orientable).

There are 415 triangulations in this section.

## SEC_6_NOR

const char regina::SnapPeaCensusTri::SEC_6_NOR

static

Represents the collection of non-orientable triangulations formed from six tetrahedra.

There are 259 triangulations in this section.

## SEC_6_OR

const char regina::SnapPeaCensusTri::SEC_6_OR

static

Represents the collection of orientable triangulations formed from six tetrahedra.

There are 962 triangulations in this section.

## SEC_7_NOR

const char regina::SnapPeaCensusTri::SEC_7_NOR

static

Represents the collection of non-orientable triangulations formed from seven tetrahedra.

There are 887 triangulations in this section.

## SEC_7_OR

const char regina::SnapPeaCensusTri::SEC_7_OR

static

Represents the collection of orientable triangulations formed from seven tetrahedra.

There are 3552 triangulations in this section.

The documentation for this class was generated from the following file:

- subcomplex/snappeacensustri.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).